<template>
  <div
    class="wrapper"
  >
    <div class="container">
      <div class="statistics">
        <header
          class="statistics-header"
          v-waypoint="{active: isWaypointActive.header, callback: animateHeader, options: {threshold: [0.25, 1]}}"
        >
          <div class="statistics__title">
            Statistics
          </div>
          <CommonGradient class="statistics__gradient"/>
        </header>
        <main class="statistics-main">
          <div
            class="statistics-counters"
            v-waypoint="{active: isWaypointActive.counters, callback: animateCounters, options: {threshold: [0.25, 1]}}"
          >
            <div class="statistics-counters-item">
              <div class="statistics-counters-item__count">1</div>
              <div class="statistics-counters-item__text">Lorem ipsum</div>
            </div>
            <div class="statistics-counters-item">
              <div class="statistics-counters-item__count">1</div>
              <div class="statistics-counters-item__text">Lorem ipsum</div>
            </div>
            <div class="statistics-counters-item">
              <div class="statistics-counters-item__count">1</div>
              <div class="statistics-counters-item__text">Lorem ipsum</div>
            </div>
            <div class="statistics-counters-item">
              <div class="statistics-counters-item__count">1</div>
              <div class="statistics-counters-item__text">Lorem ipsum</div>
            </div>
          </div>
          <div
            class="statistics-cards"
            v-waypoint="{active: isWaypointActive.cards, callback: animateCards, options: {threshold: [0.6, 1]}}"
          >
            <div
              class="statistics-cards-item-wrapper"
              v-for="(dataTranslate, index) in [200, 100, 0, -100, -200]"
              :key="index"
            >
              <div class="statistics-cards-item">
                <div class="statistics-cards-item__image" :data-translate="dataTranslate"/>
              </div>
            </div>

          </div>
          <div
            class="statistics-features"
            v-waypoint="{active: isWaypointActive.features, callback: animateFeatures, options: {threshold: [0.2, 1]}}"
          >
            <div
              class="statistics-features-item"
              v-for="(feature, idx) in features"
              :key="idx"
            >
              <div class="statistics-features-item__title">
                {{ feature.title }}
              </div>
              <div class="statistics-features-item__text">
                {{ feature.text }}
              </div>
              <div class="statistics-features-item-card">
                <div
                  class="statistics-features-item-card__image"
                  :style="`background-image: url(${feature.image})`"
                />
              </div>
            </div>
          </div>
        </main>
        <div
          v-waypoint="{active: isWaypointActive.btn, callback: animateBtn, options: {threshold: [0.5, 1]}}"
          class="btn btn_green-filled statistics__btn"
        >
          Start now
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import CommonGradient from "@/components/common/CommonGradient";
import isMobilePlatform from "@/utils";

export default {
  name: "MainPageStatistics",
  components: {CommonGradient},
  data() {
    return {
      isWaypointActive: {
        header: true,
        counters: true,
        cards: true,
        features: true,
        btn: true,
      }
    }
  },
  methods: {
    animateHeader({going}) {
      if (going !== 'in') return

      this.$anime.timeline({
        easing: 'easeOutSine'
      })
        .add({
          targets: '.statistics__title',
          translateY: [-100, 0],
          opacity: [0, 1]
        })
        .add({
          targets: '.statistics__gradient',
          opacity: [0, 1],
          width: [0, '100%']
        })

      this.isWaypointActive.header = false
    },
    animateCounters({going}) {
      if (going !== 'in') return

      this.$anime.timeline({
        delay: (el, i) => i * 250,
      })
        .add({
          targets: '.statistics-counters-item',
          easing: 'easeOutSine',
          opacity: [0, 1],
          duration: 850,
          translateX: [200, 0],
        })
        .add({
          targets: '.statistics-counters-item__count',
          delay: (el, i) => i * 250,
          easing: 'easeOutSine',
          duration: 2000,
          innerText: [0, (el, i) => (i + 5) * this.$anime.random(1, 1000)],
          round: 1
        }, 0)


      this.isWaypointActive.counters = false
    },
    animateCards({going}) {
      if (going !== 'in') return

      const tl = this.$anime.timeline({
        easing: 'easeOutSine',
      })
        .add({
          targets: '.statistics-cards-item',
          opacity: [0, 1],
          delay: this.$anime.stagger(200, {from: 'center'}),
          height: [0, '100%'],
          duration: 750
        })
        .add({
          targets: '.statistics-cards-item__image',
          opacity: [0, 1],
          delay: this.$anime.stagger(200, {from: 'center'}),
          scale: [0.8, 1],
          translateX: el => [el.getAttribute('data-translate'), 0],
          duration: 750
        }, 800)

      this.isWaypointActive.cards = false
    },
    animateFeatures({going}) {
      if (going !== 'in') return

      const tl = this.$anime.timeline({
        easing: 'easeOutSine',
      })
        .add({
          targets: '.statistics-features-item',
          delay: (_, i) => i * 200,
          translateY: [100, 0],
          opacity: [0, 1]
        })

      this.isWaypointActive.features = false
    },
    animateBtn({going}) {
      if (going !== 'in') return

      this.$anime({
        targets: '.statistics__btn',
        translateY: () => isMobilePlatform() ? [50, 0] : [200, 0],
        opacity: [0, 1],
        duration: 1000,
        easing: 'easeOutSine'
      })

      this.isWaypointActive.btn = false
    }
  },
  computed: {
    features: () => [
      {
        title: 'Play to earn',
        text: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed lacus ut mauris vestibulum pellentesque.',
        image: require('@/assets/images/statistics/features/feature_1.png')
      },
      {
        title: 'Buy NFTS',
        text: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed lacus ut mauris vestibulum pellentesque.',
        image: require('@/assets/images/statistics/features/feature_2.png')
      },
      {
        title: 'Sell NFTS',
        text: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed lacus ut mauris vestibulum pellentesque.',
        image: require('@/assets/images/statistics/features/feature_3.png')
      },
    ]
  }
}
</script>

<style scoped lang="sass">
@import "~@/assets/sass/components/MainPage/MainPageStatistics.sass"
</style>
